--Legal Notice: (C)2007 Altera Corporation. All rights reserved.  Your
--use of Altera Corporation's design tools, logic functions and other
--software and tools, and its AMPP partner logic functions, and any
--output files any of the foregoing (including device programming or
--simulation files), and any associated documentation or information are
--expressly subject to the terms and conditions of the Altera Program
--License Subscription Agreement or other applicable license agreement,
--including, without limitation, that your use is for the sole purpose
--of programming logic devices manufactured by Altera and sold by Altera
--or its authorized distributors.  Please refer to the applicable
--agreement for further details.


-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity uicontrol is 
        port (
              -- inputs:
                 signal address : IN STD_LOGIC_VECTOR (4 DOWNTO 0);
                 signal chipselect : IN STD_LOGIC;
                 signal clk : IN STD_LOGIC;
                 signal key : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal read : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;
                 signal switch : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                 signal write : IN STD_LOGIC;
                 signal writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

              -- outputs:
                 signal hex0 : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal hex1 : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal hex2 : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal hex3 : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal hex4 : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal hex5 : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal hex6 : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal hex7 : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
              );
end entity uicontrol;


architecture europa of uicontrol is
component uicontroller is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (4 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal key : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal read : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal switch : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                    signal write : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

                 -- outputs:
                    signal hex0 : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal hex1 : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal hex2 : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal hex3 : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal hex4 : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal hex5 : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal hex6 : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal hex7 : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component uicontroller;

                signal internal_hex0 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal internal_hex1 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal internal_hex2 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal internal_hex3 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal internal_hex4 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal internal_hex5 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal internal_hex6 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal internal_hex7 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal internal_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);

begin

  --the_uicontroller, which is an e_instance
  the_uicontroller : uicontroller
    port map(
      hex0 => internal_hex0,
      hex1 => internal_hex1,
      hex2 => internal_hex2,
      hex3 => internal_hex3,
      hex4 => internal_hex4,
      hex5 => internal_hex5,
      hex6 => internal_hex6,
      hex7 => internal_hex7,
      readdata => internal_readdata,
      address => address,
      chipselect => chipselect,
      clk => clk,
      key => key,
      read => read,
      reset_n => reset_n,
      switch => switch,
      write => write,
      writedata => writedata
    );


  --vhdl renameroo for output signals
  hex0 <= internal_hex0;
  --vhdl renameroo for output signals
  hex1 <= internal_hex1;
  --vhdl renameroo for output signals
  hex2 <= internal_hex2;
  --vhdl renameroo for output signals
  hex3 <= internal_hex3;
  --vhdl renameroo for output signals
  hex4 <= internal_hex4;
  --vhdl renameroo for output signals
  hex5 <= internal_hex5;
  --vhdl renameroo for output signals
  hex6 <= internal_hex6;
  --vhdl renameroo for output signals
  hex7 <= internal_hex7;
  --vhdl renameroo for output signals
  readdata <= internal_readdata;

end europa;

